'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createState;

var _getKeyInjector = require('./getKeyInjector');

var _getKeyInjector2 = _interopRequireDefault(_getKeyInjector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createState(newValues, prevValues) {

  var newStateContainer = {};
  var proxyStateContainer = {};

  if (prevValues) Object.keys(prevValues).filter(function (key) {
    return !newValues.hasOwnProperty(key);
  }).forEach((0, _getKeyInjector2.default)(newStateContainer, proxyStateContainer, prevValues, newValues));else Object.keys(newValues).filter(function (key) {
    return typeof newValues[key] === 'function';
  }).forEach(function (key) {
    newValues[key].updatedBy = {};
  });

  Object.keys(newValues).forEach((0, _getKeyInjector2.default)(newStateContainer, proxyStateContainer, newValues));

  Object.defineProperty(newStateContainer, 'copy', {
    enumerable: false,
    writable: false,
    value: function value() {
      var newValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return createState(newValues, newStateContainer);
    }
  });

  return newStateContainer;
}