'use strict';

var _getKeyInjector = require('./getKeyInjector');

var _chai = require('chai');

describe('getKeyInjector', function () {
    it('should create state proxy to set getter dependencies', function () {
        var someFn = function someFn() {};
        someFn.updatedBy = {};

        var initialState = { a: 1, b: 2, '@@c': function c() {}
        };

        Object.defineProperty(initialState, 'c', {
            enumerable: false,
            get: function get() {
                return 3;
            }
        });

        var proxy = (0, _getKeyInjector.getProxyContainer)(someFn, initialState);

        (0, _chai.expect)(proxy.a).equals(1);
        (0, _chai.expect)(proxy.c).equals(3);
        (0, _chai.expect)(someFn.updatedBy.a).equals(true);
        (0, _chai.expect)(someFn.updatedBy.c).equals(true);
        (0, _chai.expect)(someFn.updatedBy.b).not.equals(true);
    });
});